﻿Public Interface IAppRemManager

    Property Var_objDevice() As clsDevice
    Property VAR_objClientCol() As Collection
    Property VAR_clientTransQ() As System.Collections.Queue
    Property VAR_clientTransQCol() As Collection
    Property VAR_clientDataStatusCol() As Collection
    Property VAR_objDataQ() As System.Collections.Queue

    Sub AddItem2DeviceAdHocCmdQueue(ByVal tempStr As String)
    Sub AddItem2ObjDataQ(ByVal tempObj As clsData)

    Function AddItem2ObjClientCol(ByVal tempObj As clsClient) As Boolean
    Function AddItem2ClientTransQCol(ByVal tempData As String, ByVal clientID As String) As Boolean
    Function UpdateClientDataStatusItem(ByVal clientID As String, ByVal isDownloaded As Boolean) As Boolean
    Function DelItemFromObjClientCol(ByVal tempKey As String) As Boolean

End Interface


Public Class clsDevice

    Inherits MarshalByRefObject

    Private AdHocCmdQueue As System.Collections.Queue

    Private Sub RefreshAdHocCmdQueue()

        AdHocCmdQueue = Nothing
        AdHocCmdQueue = Queue.Synchronized(New Queue)

    End Sub

    Public Property VAR_AdHocCmdQueue() As System.Collections.Queue
        Get
            VAR_AdHocCmdQueue = AdHocCmdQueue
        End Get
        Set(ByVal value As System.Collections.Queue)
            AdHocCmdQueue = value
        End Set
    End Property

    Public Sub New()
        Call RefreshAdHocCmdQueue()
    End Sub
End Class

Public Class clsClient
    Inherits MarshalByRefObject

    Private Mykey As String
    Private ipAddress As String
    Private remotingPort As Integer
    Private remotingURL As String
    Private isConnected As Boolean

    Public Property VAR_isConnected() As Boolean
        Get
            VAR_isConnected = isConnected
        End Get
        Set(ByVal value As Boolean)
            isConnected = value
        End Set
    End Property
    Public Property VAR_remotingURL() As String
        Get
            VAR_remotingURL = remotingURL
        End Get
        Set(ByVal value As String)
            remotingURL = value
        End Set
    End Property

    Public Property VAR_Mykey() As String
        Get
            VAR_Mykey = Mykey
        End Get
        Set(ByVal value As String)
            Mykey = value
        End Set
    End Property

    Public Property VAR_ipAddress() As String
        Get
            VAR_ipAddress = ipAddress
        End Get
        Set(ByVal value As String)
            ipAddress = value
        End Set
    End Property

    Public Property VAR_remotingPort() As Integer
        Get
            VAR_remotingPort = remotingPort
        End Get
        Set(ByVal value As Integer)
            remotingPort = value
        End Set
    End Property

End Class

Public Class clsClientDataStatus
    Inherits MarshalByRefObject

    Private clientID As String
    Private isDownloaded As Boolean
    Private lastUpdated As Date

    Public Property VAR_clientID() As String
        Get
            VAR_clientID = clientID
        End Get
        Set(ByVal value As String)
            clientID = value
        End Set
    End Property

    Public Property VAR_isDownloaded() As Boolean
        Get
            VAR_isDownloaded = isDownloaded
        End Get
        Set(ByVal value As Boolean)
            isDownloaded = value
        End Set
    End Property

    Public Property VAR_lastUpdated() As Date
        Get
            VAR_lastUpdated = lastUpdated
        End Get
        Set(ByVal value As Date)
            lastUpdated = value
        End Set
    End Property
End Class

Public Class clsData
    Inherits MarshalByRefObject

    Private textData As String
    Private objData As Object

    Public Property VAR_textData() As String
        Get
            VAR_textData = textData
        End Get
        Set(ByVal value As String)
            textData = value
        End Set
    End Property

    Public Property VAR_objData() As Object
        Get
            VAR_objData = objData
        End Get
        Set(ByVal value As Object)
            objData = value
        End Set
    End Property

End Class

Public Class AppRemManager
    Inherits MarshalByRefObject
    Implements IAppRemManager
    Implements IDisposable

    Private ObjUserCol As Collection
    Private ObjUserColLock As System.Threading.ReaderWriterLock
    Private objDevice As clsDevice
    Private syncPointWriteThread As Integer

    Private objClientCol As Collection
    Private clientTransQ As System.Collections.Queue
    Private clientTransQCol As Collection
    Private clientDataStatusCol As Collection
    Private clientDataStatusColLock As System.Threading.ReaderWriterLock
    Private objDataQ As System.Collections.Queue

    Private Sub RefreshObjDataQ()
        objDataQ = Nothing
        objDataQ = Queue.Synchronized(New Queue)

    End Sub

    Private Sub RefreshClientDataStatusColLock()
        clientDataStatusColLock = Nothing
        clientDataStatusColLock = New System.Threading.ReaderWriterLock
    End Sub

    Private Sub RefreshClientDataStatusCol()
        clientDataStatusCol = Nothing
        clientDataStatusCol = New Collection
    End Sub

    Private Sub RefreshClientTransQCol()

        clientTransQCol = Nothing
        clientTransQCol = New Collection
    End Sub

    Private Sub RefreshObjDevice()
        objDevice = Nothing
        objDevice = New clsDevice
    End Sub

    Private Sub RefreshObjClientCol()

        objClientCol = Nothing
        objClientCol = New Collection
    End Sub

    Private Sub RefreshObjUserCol()
        ObjUserCol = Nothing
        ObjUserCol = New Collection
    End Sub


    Private Sub RefreshObjUserColLock()
        ObjUserColLock = Nothing
        ObjUserColLock = New System.Threading.ReaderWriterLock
    End Sub

    Public Sub RefreshClientTransQ()

        clientTransQ = Nothing
        clientTransQ = Queue.Synchronized(New Queue)

    End Sub


    Public Function AddItem2ObjClientCol(ByVal tempObj As clsClient) As Boolean _
    Implements IAppRemManager.AddItem2ObjClientCol

        Try

            If Not objClientCol.Contains(tempObj.VAR_Mykey) Then

                Call objClientCol.Add(tempObj, tempObj.VAR_Mykey)

                '==== create client Data status (23 Aug 2010) ==================
                If Not CreateClientDataStatus(tempObj) Then
                    '=== exception handler =======
                End If

                AddItem2ObjClientCol = True
            Else
                AddItem2ObjClientCol = False
            End If 'If Not objClientCol.Contains(tempObj.VAR_Mykey) Then

        Catch ex1 As System.Runtime.Remoting.RemotingException
            AddItem2ObjClientCol = False
            MsgBox(ex1.ToString & vbCrLf & ex1.Message & vbCrLf & ex1.StackTrace)

        Catch ex As Exception
            AddItem2ObjClientCol = False
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Function

    Public Function DelItemFromObjClientCol(ByVal tempKey As String) As Boolean _
    Implements IAppRemManager.DelItemFromObjClientCol

        Try

            If Not objClientCol Is Nothing Then

                Call objClientCol.Remove(tempKey)
                DelItemFromObjClientCol = True

            End If 'If Not objClientCol Is Nothing

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)

            DelItemFromObjClientCol = False
        End Try

    End Function

    Public Property VAR_objDataQ() As System.Collections.Queue _
    Implements IAppRemManager.VAR_objDataQ
        Get
            VAR_objDataQ = objDataQ
        End Get
        Set(ByVal value As System.Collections.Queue)
            objDataQ = value
        End Set
    End Property

    Public Property VAR_clientDataStatusCol() As Collection _
    Implements IAppRemManager.VAR_clientDataStatusCol
        Get
            VAR_clientDataStatusCol = clientDataStatusCol
        End Get
        Set(ByVal value As Collection)
            clientDataStatusCol = value
        End Set
    End Property

    Public Property VAR_clientTransQCol() As Collection _
    Implements IAppRemManager.VAR_clientTransQCol
        Get
            VAR_clientTransQCol = clientTransQCol
        End Get
        Set(ByVal value As Collection)
            clientTransQCol = value
        End Set
    End Property

    Public Property VAR_clientTransQ() As System.Collections.Queue Implements IAppRemManager.VAR_clientTransQ
        Get
            VAR_clientTransQ = clientTransQ
        End Get
        Set(ByVal value As System.Collections.Queue)
            clientTransQ = value
        End Set
    End Property

    Public Property VAR_objClientCol() As Collection Implements IAppRemManager.VAR_objClientCol
        Get
            VAR_objClientCol = objClientCol
        End Get
        Set(ByVal value As Collection)
            objClientCol = value
        End Set
    End Property

    Public Property VAR_ObjUserColLock() As System.Threading.ReaderWriterLock
        Get
            VAR_ObjUserColLock = ObjUserColLock
        End Get
        Set(ByVal value As System.Threading.ReaderWriterLock)
            ObjUserColLock = value
        End Set
    End Property

    Public Property VAR_ObjUserCol() As Collection
        Get
            VAR_ObjUserCol = ObjUserCol
        End Get
        Set(ByVal value As Collection)
            ObjUserCol = value
        End Set
    End Property

    Public Property Var_objDevice() As clsDevice _
    Implements IAppRemManager.Var_objDevice
        Get
            Var_objDevice = objDevice
        End Get
        Set(ByVal value As clsDevice)
            objDevice = value
        End Set
    End Property


    Public Sub AddItem2ObjDataQ(ByVal tempObj As clsData) _
    Implements IAppRemManager.AddItem2ObjDataQ

        Try
            If Not objDataQ Is Nothing Then

                objDataQ.Enqueue(tempObj)

            End If 'If Not objDataQ Is Nothing

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

    Public Sub AddItem2DeviceAdHocCmdQueue(ByVal tempStr As String) _
    Implements IAppRemManager.AddItem2DeviceAdHocCmdQueue
        Dim tempQueue As System.Collections.Queue

        If Not objDevice Is Nothing Then

            tempQueue = objDevice.VAR_AdHocCmdQueue

            If Not tempQueue Is Nothing Then
                Try
                    tempQueue.Enqueue(tempStr)
                Catch ex As Exception

                End Try

            End If ' If Not tempQueue Is Nothing Then

        End If 'If Not objDevice Is Nothing Then

    End Sub

    Public Function AddItem2ClientTransQCol(ByVal tempData As String, ByVal clientID As String) As Boolean _
        Implements IAppRemManager.AddItem2ClientTransQCol
        Dim tempQ As System.Collections.Queue
        Dim tempObj As clsClientDataStatus

        Try

            If Not clientID = "" Then

                '=== check to see if client has already download a byVal reference ? =========
                If Not clientDataStatusCol Is Nothing Then

                    If clientDataStatusCol.Contains(clientID) Then

                        tempObj = clientDataStatusCol.Item(clientID)

                        If Not tempObj Is Nothing Then

                            If Not clientTransQCol Is Nothing Then

                                If clientTransQCol.Contains(clientID) Then

                                    If tempObj.VAR_isDownloaded Then
                                        '===1. If downloaded =========================================================
                                        '---- Delete previous queue, 
                                        '---- this will not affect the client's process because client will have a byVal reference of the same object 
                                        Call clientTransQCol.Remove(clientID)

                                        '=== crate a new queue object ======
                                        tempQ = Nothing
                                        tempQ = Queue.Synchronized(New Queue)

                                        If Not tempQ Is Nothing Then

                                            Call tempQ.Enqueue(tempData)
                                            Call clientTransQCol.Add(tempQ, clientID)

                                        End If 'If Not tempQ Is Nothing Then

                                        '=== reset the client data status to false============
                                        tempObj.VAR_isDownloaded = False
                                        tempObj.VAR_lastUpdated = Now

                                        AddItem2ClientTransQCol = True

                                    Else
                                        '===2. If not downloaded, add to existing queue =====================================================
                                        tempQ = Nothing
                                        tempQ = clientTransQCol.Item(clientID)

                                        If Not tempQ Is Nothing Then

                                            Call tempQ.Enqueue(tempData)

                                            tempObj.VAR_lastUpdated = Now

                                            AddItem2ClientTransQCol = True

                                        End If 'If Not tempQ Is Nothing Then

                                    End If ' If tempObj.VAR_isDownloaded Then



                                Else
                                    '=== First timer ===================
                                    '=== crate a new queue object ======
                                    tempQ = Nothing
                                    tempQ = Queue.Synchronized(New Queue)

                                    If Not tempQ Is Nothing Then

                                        Call tempQ.Enqueue(tempData)
                                        Call clientTransQCol.Add(tempQ, clientID)

                                        tempObj.VAR_lastUpdated = Now

                                        AddItem2ClientTransQCol = True
                                    End If 'If Not tempQ Is Nothing Then

                                End If 'If clientTransQCol.Contains(clientID) Then

                            Else
                                AddItem2ClientTransQCol = False
                            End If 'If Not clientTransQCol Is Nothing Then

                        Else
                            AddItem2ClientTransQCol = False
                        End If 'If Not tempObj Is Nothing Then

                    Else
                        AddItem2ClientTransQCol = False
                    End If 'If clientDataStatusCol.Contains(clientID) Then

                Else
                    AddItem2ClientTransQCol = False
                End If 'If Not clientDataStatusCol Is Nothing Then

            Else
                AddItem2ClientTransQCol = False
            End If 'If Not clientID = "" Then

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Function

    '=== 23 Aug 2010 ==========================
    Private Function CreateClientDataStatus(ByVal tempObj As clsClient) As Boolean
        Dim objClientDataStatus As clsClientDataStatus

        Try

            If Not tempObj Is Nothing Then

                If Not clientDataStatusCol Is Nothing Then

                    If Not clientDataStatusCol.Contains(tempObj.VAR_Mykey) Then
                        objClientDataStatus = New clsClientDataStatus
                        objClientDataStatus.VAR_clientID = tempObj.VAR_Mykey
                        objClientDataStatus.VAR_isDownloaded = False
                        Call clientDataStatusCol.Add(objClientDataStatus, tempObj.VAR_Mykey)

                        CreateClientDataStatus = True
                    Else
                        CreateClientDataStatus = False
                    End If 'If Not clientDataStatusCol.Contains(tempObj.VAR_Mykey) Then

                Else
                    CreateClientDataStatus = False
                End If 'If Not clientDataStatusCol Is Nothing Then

            Else
                CreateClientDataStatus = False
            End If 'If Not tempObj Is Nothing Then

        Catch ex As Exception
            CreateClientDataStatus = False
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Function

    '=== 23 Aug 2010 ==========================
    '=== clientID = IP@Port ===================
    Public Function UpdateClientDataStatusItem(ByVal clientID As String, ByVal IsDownloaded As Boolean) As Boolean _
    Implements IAppRemManager.UpdateClientDataStatusItem

        Dim tempCount As Integer
        Dim tempObj As clsClientDataStatus

        If Not clientDataStatusCol Is Nothing Then

            '=== need to implement lock here =====
            If Not clientDataStatusColLock Is Nothing Then

                Do
                    Try
                        clientDataStatusColLock.AcquireWriterLock(100) '10 seconds
                    Catch Ex As System.ApplicationException
                        'System.Diagnostics.Debug.WriteLine(Ex.Message)
                    Finally
                        tempCount += 1
                    End Try

                Loop While (Not clientDataStatusColLock.IsWriterLockHeld And tempCount < 10)

                If clientDataStatusColLock.IsWriterLockHeld Then

                    Try
                        If clientDataStatusCol.Contains(clientID) Then
                            tempObj = clientDataStatusCol.Item(clientID)
                            tempObj.VAR_isDownloaded = IsDownloaded  'update the flag 
                            If IsDownloaded = True Then
                                '--- reset to default --------------------
                                tempObj.VAR_lastUpdated = New Date(1, 1, 1)
                            End If 'If IsDownloaded = True Then

                            UpdateClientDataStatusItem = True
                        Else
                            UpdateClientDataStatusItem = False
                        End If 'If clientDataStatusCol.Contains(clientID) Then

                    Catch ex As Exception
                        UpdateClientDataStatusItem = False
                    Finally
                        Call clientDataStatusColLock.ReleaseWriterLock()
                    End Try

                Else
                    'System.Diagnostics.Debug.WriteLine("Write lock not acquired successfully after 10 tries")
                    UpdateClientDataStatusItem = False
                End If 'If clientDataStatusColLock.IsWriterLockHeld Then
            Else
                '==== Do nothing========================
                UpdateClientDataStatusItem = False
            End If 'If not clientDataStatusColLock Is Nothing Then

        Else
            UpdateClientDataStatusItem = False
        End If 'If Not clientDataStatusCol Is Nothing Then



    End Function

    Public Sub New()

        Call RefreshObjUserCol()
        Call RefreshObjUserColLock()
        Call RefreshObjDevice()
        Call RefreshObjClientCol()
        Call RefreshClientTransQ()
        Call RefreshClientTransQCol()
        Call RefreshClientDataStatusCol()
        Call RefreshClientDataStatusColLock()
        Call RefreshObjDataQ()

    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub

#Region " IDisposable Support "
    ' This code added by Visual Basic to correctly implement the disposable pattern.
    Public Sub Dispose() Implements IDisposable.Dispose
        ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
        Dispose(True)
        GC.SuppressFinalize(Me)
    End Sub

    Private disposedValue As Boolean = False        ' To detect redundant calls

    ' IDisposable
    Protected Overridable Sub Dispose(ByVal disposing As Boolean)
        If Not Me.disposedValue Then
            If disposing Then
                ' TODO: free other state (managed objects).
            End If

            ' TODO: free your own state (unmanaged objects).
            ' TODO: set large fields to null.
        End If
        Me.disposedValue = True
    End Sub

#End Region

End Class

Public Class AppAPI

End Class
