﻿
Imports System
Imports System.Runtime.Remoting
Imports AppAPI
Imports System.Runtime.Remoting.Channels.Http
Imports System.Runtime.Remoting.Channels.Tcp
Imports System.Runtime.Remoting.Channels
Imports System.Net
Imports System.Net.Sockets

Public Class Form1

#Region "Variables"

    Private ObjAppRemManager As IAppRemManager
    Private ReadingTimer As System.Timers.Timer
    Private Delegate Sub updateTextBox_dlgt(ByVal tempStr As String)
    Private Delegate Sub updateTimerBtn1_dlgt(ByVal tempStr As String)
    Private syncPointReadThread As Integer
    Private syncPointReadThread2 As Integer
    Private MyGuid As Guid
    Private objClient As clsClient
    Private channel As HttpChannel

#End Region

#Region "Refresh Objects"

   
#End Region

#Region "Private Methods"

    Private Sub StartReadingTimer()
        ' Create a timer with a one second interval.
        ReadingTimer = New System.Timers.Timer(1000)

        ' Hook up the Elapsed event for the timer.
        'AddHandler ReadingTimer.Elapsed, AddressOf StartReadProcess
        AddHandler ReadingTimer.Elapsed, AddressOf ProcessTransQCol

        ReadingTimer.Enabled = True

    End Sub

   
    Private Function RetrieveLocalIPAdd() As String

        Dim tempHostName As String

        tempHostName = System.Environment.MachineName

        ' Get server related information.
        Dim heserver As IPHostEntry = Dns.GetHostEntry(tempHostName)

        ' Loop on the AddressList
        Dim curAdd As IPAddress

        RetrieveLocalIPAdd = ""

        For Each curAdd In heserver.AddressList

            '== do not retrieve IPv6 address =====
            If Not curAdd.AddressFamily.ToString() = ProtocolFamily.InterNetworkV6.ToString() Then

                '== Only one is expected ====
                RetrieveLocalIPAdd = curAdd.ToString()
                Exit For

            End If

        Next curAdd

    End Function

    Private Function StartRemotingService() As Boolean

        Dim serverProv As New BinaryServerFormatterSinkProvider()
        Dim clientProv As New BinaryClientFormatterSinkProvider()
        Dim props As Hashtable
        'Dim chnl As HttpChannel
        Dim chnl2 As TcpChannel

        Try

            If Not objClient Is Nothing Then

                serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full

                props = New Hashtable()
                props.Add("port", objClient.VAR_remotingPort)
                'chnl = New HttpChannel(props, clientProv, serverProv)
                chnl2 = New TcpChannel(props, clientProv, serverProv)

                'ChannelServices.RegisterChannel(chnl, False)
                ChannelServices.RegisterChannel(chnl2, False)

                '==== using register wellknown singleton=====================
                'RemotingConfiguration.RegisterWellKnownServiceType( _
                '    GetType(AppRemManager), _
                '    "AppRemManager.soap", _
                '    WellKnownObjectMode.Singleton)
                '==================================================

                '==== Using published marshal =======================
                ObjAppRemManager = New AppRemManager
                RemotingServices.Marshal(ObjAppRemManager, objClient.VAR_remotingURL)
                '==================================================
                StartRemotingService = True
            Else
                StartRemotingService = False
            End If ' If Not objClient Is Nothing Then

        Catch ex As Exception
            StartRemotingService = False
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Function

    Private Sub RegisterClientToServer()

        Dim localIPAddress As String
        Dim randNum As Random

        localIPAddress = RetrieveLocalIPAdd()

        objClient = New clsClient
        If Not objClient Is Nothing Then

            Try

                If Not ObjAppRemManager Is Nothing Then

                    objClient.VAR_remotingURL = "AppRemManagerClient.soap"
                    objClient.VAR_ipAddress = localIPAddress

                    'objClient.VAR_remotingPort = 3231  'set a port number 
                    randNum = New Random(System.DateTime.Now.Millisecond)
                    objClient.VAR_remotingPort = randNum.Next(1000, 9999)

                    objClient.VAR_Mykey = objClient.VAR_ipAddress & "@" & objClient.VAR_remotingPort

                    objClient.VAR_isConnected = True

                    If ObjAppRemManager.AddItem2ObjClientCol(objClient) Then

                        '--- start reading timer ----
                        Call StartReadingTimer0()

                        MsgBox("Current client added to server successful!", MsgBoxStyle.Information)

                    Else
                        MsgBox("Current client NOT added to server successful!", MsgBoxStyle.Critical)

                        Call StopReadingTimer()
                        Call ResetChannel()
                        Label1.Text = ""

                    End If 'If ObjAppRemManager.AddItem2ObjClientCol

                Else
                    MsgBox("Server reference not created!", MsgBoxStyle.Critical)
                End If 'If Not ObjAppRemManager Is Nothing

            Catch ex1 As System.Net.WebException

                '--- server disconnected -----------
                MsgBox("server not connected", MsgBoxStyle.Critical)
                MsgBox(ex1.ToString & vbCrLf & ex1.Message & vbCrLf & ex1.StackTrace)

                Call StopReadingTimer()
                Call ResetChannel()
                Label1.Text = ""

            Catch ex2 As RemotingException

                '--- server disconnected -----------
                MsgBox("server not connected", MsgBoxStyle.Critical)
                MsgBox(ex2.ToString & vbCrLf & ex2.Message & vbCrLf & ex2.StackTrace)

                Call StopReadingTimer()
                Call ResetChannel()
                Label1.Text = ""

            Catch ex As Exception
                MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
            End Try

        End If 'If Not objClient Is Nothing Then

    End Sub

    Private Sub RemoveClientFrmServer()

        Try

            '---- set the object reference to nothing ------
            If Not objClient Is Nothing Then
                objClient.VAR_isConnected = False
            End If ' If Not objClient Is Nothing 


        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

    Private Sub ProcessTransQCol()

        Dim clientID As String
        Dim tempQ As System.Collections.Queue
        Dim objClientDataStatus As clsClientDataStatus
        Dim tempData As String

        Try

            If Not ObjAppRemManager Is Nothing Then

                clientID = objClient.VAR_Mykey

                If Not ObjAppRemManager.VAR_clientTransQCol Is Nothing Then

                    If ObjAppRemManager.VAR_clientTransQCol.Contains(clientID) Then

                        tempQ = ObjAppRemManager.VAR_clientTransQCol.Item(clientID)
                        objClientDataStatus = ObjAppRemManager.VAR_clientDataStatusCol.Item(clientID)

                        If Not objClientDataStatus Is Nothing Then

                            '== check if is not default date (23 Aug 2010) ==============
                            If Not objClientDataStatus.VAR_lastUpdated = New Date(1, 1, 1) Then

                                'MsgBox(tempQ.Count)

                                '== Display data ======
                                If Not tempQ.Count = 0 Then

                                    Do While (tempQ.Count <> 0)
                                        tempData = tempQ.Dequeue
                                        Call updateTextBox_ThreadSafe(tempData & vbCrLf)
                                    Loop

                                End If 'If Not tempQ.Count = 0 Then

                                '=== reset client data status to true ======
                                If ObjAppRemManager.UpdateClientDataStatusItem(clientID, True) Then
                                    'MsgBox("Client data status updated")
                                Else
                                    'MsgBox("Client data status NOT updated")

                                End If 'If ObjAppRemManager.UpdateClientDataStatusItem(clientID, True) Then

                            End If 'If Not objClientDataStatus.VAR_lastUpdated =

                        Else
                            MsgBox("objClientDataStatus Is Nothing")
                        End If ' If Not objClientDataStatus Is Nothing Then

                    Else
                        'MsgBox("ObjAppRemManager.VAR_clientTransQCol does not contain queue for " & clientID, MsgBoxStyle.Critical)
                    End If 'If ObjAppRemManager.VAR_clientTransQCol.Contains(clientID) Then
                Else
                    'MsgBox("ObjAppRemManager.VAR_clientTransQCol Is Nothing", MsgBoxStyle.Critical)
                End If 'If Not ObjAppRemManager.VAR_clientTransQCol Is Nothing Then

            End If 'If Not ObjAppRemManager Is Nothing Then

        Catch ex1 As RemotingException

            Call StopReadingTimer()

        Catch ex As Exception
            Call StopReadingTimer()

            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)

        End Try

    End Sub

    Private Sub StartReadingTimer0()

        Call updateTimerBtn1_ThreadSafe("Stop Read Process")
        Call StartReadingTimer()

    End Sub

    Private Sub StopReadingTimer()

        Call updateTimerBtn1_ThreadSafe("Start Read Process")

        If Not ReadingTimer Is Nothing Then
            ReadingTimer.Stop()
            ReadingTimer.Enabled = False

        End If 'If Not ReadingTimer Is Nothing 

    End Sub

#End Region

#Region "ThreadSafe"

    '=== Related to multi-threading =======

    Public Sub updateTextBox_ThreadSafe(ByVal tempStr As String)

        If TextBox1.InvokeRequired Then

            Dim updateTextBox_obj As New updateTextBox_dlgt(AddressOf updateTextBox_ThreadSafe)
            TextBox1.Invoke(updateTextBox_obj, tempStr)

        Else
            Call updateTextBox(tempStr)

        End If
    End Sub

    Public Sub updateTimerBtn1_ThreadSafe(ByVal tempStr As String)

        If cmdStartReadTimer.InvokeRequired Then

            Dim updateTimerBtn1_obj As New updateTimerBtn1_dlgt(AddressOf updateTimerBtn1_ThreadSafe)
            cmdStartReadTimer.Invoke(updateTimerBtn1_obj, tempStr)

        Else
            Call UpdateTimerBtn1(tempStr)

        End If
    End Sub

#End Region

#Region "NonThreadSafe"

    Private Sub updateTextBox(ByVal tempStr As String)
        Application.DoEvents()
        TextBox1.AppendText(tempStr)
        TextBox1.Refresh()
    End Sub

    Private Sub UpdateTimerBtn1(ByVal tempStr As String)
        cmdStartReadTimer.Text = tempStr
    End Sub

#End Region

#Region "User Actions"

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdConnSvr.Click

        Dim srvPortNum As Integer
        Dim serverProv As BinaryServerFormatterSinkProvider
        Dim clientProv As BinaryClientFormatterSinkProvider
        Dim props As Hashtable

        Try
            serverProv = New BinaryServerFormatterSinkProvider
            serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full
            clientProv = New BinaryClientFormatterSinkProvider
            props = New Hashtable
            props.Add("port", 0)

            srvPortNum = txtPortNum.Value

            If Not TextBox2.Text = "" Then

                channel = New HttpChannel(props, clientProv, serverProv)

                ChannelServices.RegisterChannel(channel, False)

                'ObjAppRemManager = CType(Activator.GetObject( _
                '    GetType(IAppRemManager), "http://localhost:1234/AppRemManager.soap"),  _
                '    IAppRemManager)

                ObjAppRemManager = Nothing
                ObjAppRemManager = CType(Activator.GetObject( _
                    GetType(IAppRemManager), "http://" & Trim(TextBox2.Text) & ":" & srvPortNum & "/AppRemManager.soap"),  _
                    IAppRemManager)

                Label1.Text = "Server dynamic reference created!"

                Call RegisterClientToServer()

            Else
                MsgBox("Please provide the IP!", MsgBoxStyle.Critical)
            End If

        Catch ex1 As System.Net.WebException

            '--- server disconnected -----------
            MsgBox("server not connected", MsgBoxStyle.Critical)
            MsgBox(ex1.ToString & vbCrLf & ex1.Message & vbCrLf & ex1.StackTrace)

            Call StopReadingTimer()
            Call ResetChannel()

            Label1.Text = ""

        Catch ex2 As RemotingException

            '--- server disconnected -----------
            MsgBox("server not connected", MsgBoxStyle.Critical)
            MsgBox(ex2.ToString & vbCrLf & ex2.Message & vbCrLf & ex2.StackTrace)

            Call StopReadingTimer()
            Call RemoveClientFrmServer()
            Call ResetChannel()

            Label1.Text = ""

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub

    Private Sub ResetChannel()

        Try

            If Not channel Is Nothing Then

                Call ChannelServices.UnregisterChannel(channel)

            End If 'If Not chnl Is Nothing


        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStartReadTimer.Click
        If cmdStartReadTimer.Text = "Start Read Process" Then
            Call StartReadingTimer0()

        ElseIf cmdStartReadTimer.Text = "Stop Read Process" Then

            Call StopReadingTimer()

        End If

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClrTxt.Click
        Call TextBox1.Clear()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdWrite2Svr.Click

        Dim tempStr As String
        Dim objData As clsData

        Try

            If txtMessage.Text = "" Then
                tempStr = InputBox("Enter your message")
            Else
                tempStr = txtMessage.Text
            End If 'If txtMessage.Text = ""
            
            objData = New clsData
            objData.VAR_objData = objClient
            objData.VAR_textData = tempStr

            Call ObjAppRemManager.AddItem2ObjDataQ(objData)

            '--- clear txt -----
            txtMessage.Text = ""

        Catch ex1 As System.Net.WebException

            '--- server disconnected -----------
            Call updateTextBox_ThreadSafe("server disconnected,please try to reconnect" & vbCrLf)

            Call StopReadingTimer()
            Call RemoveClientFrmServer()
            Call ResetChannel()
            Label1.Text = "Server disconnected, please try to reconnect"

            '--- clear txt -----
            txtMessage.Text = ""


        Catch ex2 As RemotingException

            '--- server disconnected -----------
            Call updateTextBox_ThreadSafe("server disconnected,please try to reconnect" & vbCrLf)

            Call StopReadingTimer()
            Call RemoveClientFrmServer()
            Call ResetChannel()

            Label1.Text = "Server disconnected,please try to reconnect"

            '--- clear txt -----
            txtMessage.Text = ""

        Catch ex As Exception

            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub


    Private Sub cmdDisConnSvr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDisConnSvr.Click

        Call StopReadingTimer()

        Call RemoveClientFrmServer()

        Call ResetChannel()

        Label1.Text = ""

    End Sub

#End Region

#Region "Private Events"

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '--- Send message using return key ----
        Me.AcceptButton = Me.cmdWrite2Svr
        txtMessage.AcceptsReturn = False

    End Sub

#End Region

End Class
