﻿
Option Explicit On
'Option Strict On

Imports System
Imports System.Runtime.Remoting
Imports AppAPI
Imports System.Runtime.Remoting.Channels.Http
Imports System.Runtime.Remoting.Channels.Tcp
Imports System.Runtime.Remoting.Channels

Public Class Form1

#Region "Variables"

    Private ReadingTimer As System.Timers.Timer
    Private RefreshUserTimer As System.Timers.Timer
    Private Delegate Sub updateTextBox_dlgt(ByVal tempStr As String)
    Private Delegate Sub updateCmbClient_dlgt2(ByVal args() As Object)
    Private objAppRemManager As AppRemManager
    Private returnedRemotingObj As System.Runtime.Remoting.ObjRef
    Private syncPointReadThread As Integer
    Private syncPointRefreshThread As Integer
    Private disconnClientIndexCol As Collection
    Private localObjClientCol As Collection
    Private chnl As HttpChannel

#End Region

#Region "Refresh Objects"

    Private Sub RefreshDisconnClientIndexCol()

        disconnClientIndexCol = Nothing
        disconnClientIndexCol = New Collection
    End Sub

    Private Sub RefreshLocalObjClientCol()
        localObjClientCol = Nothing
        localObjClientCol = New Collection
    End Sub

    Private Sub RefreshObjAppRemManager()
        If Not objAppRemManager Is Nothing Then
            Call objAppRemManager.Dispose()
            objAppRemManager = Nothing
            objAppRemManager = New AppRemManager
        Else
            objAppRemManager = New AppRemManager
        End If

    End Sub

#End Region

#Region "Private Methods"

    Private Sub StartReadingTimer()
        ' Create a timer with a one second interval.
        ReadingTimer = New System.Timers.Timer(1000)

        ' Hook up the Elapsed event for the timer.
        AddHandler ReadingTimer.Elapsed, AddressOf StartReadProcess2

        ReadingTimer.Enabled = True

    End Sub

    '=== read from objDataQ (28 Oct 2010) ===============
    Private Sub StartReadProcess2(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs)

        Dim objClient As clsClient
        Dim tempObj As clsData
        Dim tempStr As String
        Dim tempRemQueue As System.Collections.Queue

        Try

            '=== temporarily stop ==========

            Call ReadingTimer.Stop()

            If System.Threading.Interlocked.CompareExchange(syncPointReadThread, 1, 0) = 0 Then

                If Not objAppRemManager Is Nothing Then

                    tempRemQueue = objAppRemManager.VAR_objDataQ

                    If Not tempRemQueue Is Nothing And Not tempRemQueue.Count = 0 Then

                        tempObj = tempRemQueue.Dequeue
                        If Not tempObj Is Nothing Then
                            objClient = DirectCast(tempObj.VAR_objData, clsClient)
                            If Not objClient Is Nothing Then
                                tempStr = objClient.VAR_Mykey & "-->" & tempObj.VAR_textData
                            Else
                                '--- unknown objClient ----
                                tempStr = tempObj.VAR_textData
                            End If

                            Call updateTextBox_ThreadSafe(tempStr & vbCrLf)
                            tempStr = ""
                        End If 'If Not tempObj Is Nothing


                    End If 'If Not tempRemQueue Is Nothing And Not tempRemQueue.Count = 0 Then

                End If 'If Not objAppRemManager Is Nothing Then

                If System.Threading.Interlocked.Exchange(syncPointReadThread, 0) = 0 Then
                    '=== exception handler ========
                    '=== something is wrong =======

                Else
                    '==== reenable =================
                    Call ReadingTimer.Start()
                End If

            End If 'If System.Threading.Interlocked.CompareExchange(syncPointReadThread, 1, 0) = 0 Then

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & ex.StackTrace)
        End Try

    End Sub

    Private Sub StartRefreshUserTimer()
        ' Create a timer with a one second interval.
        RefreshUserTimer = New System.Timers.Timer(1000)

        ' Hook up the Elapsed event for the timer.
        AddHandler RefreshUserTimer.Elapsed, AddressOf StartRefreshUserTimerProcess

        RefreshUserTimer.Enabled = True
    End Sub

    Private Sub StartRefreshUserTimerProcess(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs)
        Dim tempLock As System.Threading.ReaderWriterLock
        Dim tempCount As Integer

        '=== temporarily stop ==========
        Call RefreshUserTimer.Stop()

        If System.Threading.Interlocked.CompareExchange(syncPointRefreshThread, 1, 0) = 0 Then

            If Not objAppRemManager Is Nothing Then

                tempLock = objAppRemManager.VAR_ObjUserColLock


                If Not tempLock Is Nothing Then
                    Do
                        Try
                            tempLock.AcquireReaderLock(10000) '10 seconds
                        Catch Ex As System.ApplicationException
                            System.Diagnostics.Debug.WriteLine(Ex.Message)
                        End Try
                        tempCount += 1
                    Loop While (Not tempLock.IsReaderLockHeld And tempCount < 10)

                    If tempLock.IsReaderLockHeld Then

                        Try

                            '=== Refresh Client list (22 Aug 2010) =============
                            Call RefreshClientList()

                        Catch ex As Exception
                            System.Diagnostics.Debug.WriteLine(ex.Message)
                        Finally

                        End Try
                        Call tempLock.ReleaseReaderLock()
                    Else
                        System.Diagnostics.Debug.WriteLine("Write lock not acquired successfully after 10 tries")
                    End If

                End If 'If Not tempLock Is Nothing Then


            End If 'If Not objAppRemManager Is Nothing Then

            If System.Threading.Interlocked.Exchange(syncPointRefreshThread, 0) = 0 Then
                '=== exception handler ========
                '=== something is wrong =======

            Else
                '==== reenable =================
                Call RefreshUserTimer.Start()
            End If

        End If 'If System.Threading.Interlocked.CompareExchange(syncPointRefreshThread, 1, 0) = 0 Then

    End Sub

    '=== 22 Aug 2010 ======
    Private Sub RefreshClientList()

        Dim i As Integer
        Dim tempCol As Collection
        Dim objClient As clsClient
        'Dim args As Object() 'This is wrong (Will generate Parameter Count Mismatch)
        Dim args() As Object  'This is correct

        Try

            If Not objAppRemManager Is Nothing Then
                tempCol = objAppRemManager.VAR_objClientCol

                If Not tempCol Is Nothing Then

                    For i = 1 To tempCol.Count
                        objClient = CType(tempCol.Item(i), clsClient)

                        If Not objClient Is Nothing Then

                            '--- Determine if objClient is still connected ----
                            If IsClientConnected(objClient) Then
                                ReDim args(2)
                                args(0) = i
                                args(1) = objClient
                                args(2) = "Add"
                                Call updateCmbClient_ThreadSafe2(args)
                            Else
                                If Not disconnClientIndexCol Is Nothing Then
                                    Call disconnClientIndexCol.Add(i)
                                End If 'If Not disconnClientIndexCol
                            End If 'If IsClientConnected(objClient)

                        End If 'If Not objClient Is Nothing
                    Next

                    '--- purge disconnected client ---------
                    Call PurgeDisconnClient()
                    '---------------------------------------

                End If 'If Not tempCol Is Nothing Then

            End If 'If Not objAppRemManager Is Nothing Then

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & ex.StackTrace)
        End Try

    End Sub

    '--- 27 Oct 2010 ------------------------------
    Private Function IsClientConnected(ByVal tempObj As clsClient) As Boolean

        'Dim tempKey As String
        Dim isConnected As Boolean

        Try

            '--- try to read a property ----
            If Not tempObj Is Nothing Then
                'tempKey = tempObj.VAR_Mykey
                isConnected = tempObj.VAR_isConnected

                If isConnected Then
                    '--- still connected -------
                    IsClientConnected = True
                Else
                    '--- still connected -------
                    IsClientConnected = False
                End If
                
            End If 'If Not tempObj Is Nothing

        Catch ex1 As System.Net.WebException
            '---not connected -------------
            IsClientConnected = False

        Catch ex As Exception
           
            MsgBox(ex.ToString & vbCrLf & ex.Message & ex.StackTrace)

        End Try

    End Function

    '---- 27 Oct 2010 -------------
    Private Sub PurgeDisconnClient()
        Dim i As Integer
        Dim tempIndex As Integer
        Dim tempObj As clsClient
        Dim args() As Object

        Try

            If Not objAppRemManager Is Nothing Then

                If Not disconnClientIndexCol Is Nothing Then

                    If Not disconnClientIndexCol.Count = 0 Then

                        For i = disconnClientIndexCol.Count To 1 Step -1
                            tempIndex = disconnClientIndexCol.Item(i)

                            If Not localObjClientCol Is Nothing Then
                                If localObjClientCol.Contains(CStr(tempIndex)) Then

                                    tempObj = localObjClientCol.Item(CStr(tempIndex))

                                    If Not tempObj Is Nothing Then

                                        '--- remove from objAppRemManager ---
                                        If Not objAppRemManager.DelItemFromObjClientCol(tempObj.VAR_Mykey) Then
                                            '--- exception handler -----

                                        End If 'If Not objAppRemManager.DelItemFromObjClientCol

                                        '--- remove from cmbObjClient and localObjClientCol ---
                                        '---- Threadsafe -------------------------
                                        ReDim args(2)
                                        args(0) = tempIndex
                                        args(1) = tempObj
                                        args(2) = "Delete"
                                        Call updateCmbClient_ThreadSafe2(args)
                                        '------------------------------------------

                                        Call localObjClientCol.Remove(CStr(tempIndex))

                                        Call disconnClientIndexCol.Remove(i)

                                        '--- notify --------------------
                                        Call updateTextBox_ThreadSafe("client=" & tempObj.VAR_Mykey & " disconnected" & vbCrLf)

                                    End If 'If Not tempObj Is Nothing

                                End If 'If localObjClientCol.Contains(CStr(tempIndex))


                            End If 'If Not localObjClientCol Is Nothing
                        Next

                    End If 'If Not disconnClientIndexCol.Count = 0

                End If 'If Not disconnClientIndexCol Is Nothing

            End If 'If Not objAppRemManager Is Nothing

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & ex.StackTrace)
        End Try

    End Sub

    '---(Deprecated) This method doesn't yield anything ----
    Private Sub IsChannelAvail()
        Dim channelList() As IChannel
        Dim tempChnl As HttpChannel
        Dim tempKey As ArrayList
        Dim tempProps As IDictionary
        Dim i As Integer
        Dim tempStr As String

        Try

            tempStr = ""

            channelList = ChannelServices.RegisteredChannels

            'MsgBox(channelList.Length)
            If channelList.Length > 0 Then
                'MsgBox(channelList(0).ToString())
                'MsgBox(channelList(0).ChannelName)
                'MsgBox(channelList(0).ChannelPriority)
                tempChnl = DirectCast(channelList(0), HttpChannel)

                'MsgBox(tempChnl.Keys("port"))
                'props = tempChnl.Keys
                'MsgBox(props("port"))
                'MsgBox(tempChnl.Item("port"))

                tempKey = tempChnl.Keys

                If tempKey.Count > 0 Then

                    'tempCol = DirectCast(tempKey(0), Collection)
                    'MsgBox(tempCol.Count)
                    'MsgBox(tempKey.Item(1).ToString)

                    For i = 0 To tempKey.Count - 1
                        tempStr = tempStr & tempKey.Item(i).ToString & "=" & tempChnl.Item(tempKey.Item(i)) & vbCrLf
                    Next i

                    MsgBox(tempStr)

                End If 'If tempKey.Count > 0

                'MsgBox(tempChnl.Item("proxyport"))

                'MsgBox(tempChnl.Properties.Count)
                tempProps = tempChnl.Properties

                If tempProps.Count > 0 Then
                    MsgBox(tempProps.Item("proxyport").ToString)
                End If

            End If 'If channelList.Length > 0

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

#End Region

#Region "ThreadSafe"

    '=== Related to multi-threading =======

    Public Sub updateTextBox_ThreadSafe(ByVal tempStr As String)

        If TextBox1.InvokeRequired Then

            Dim updateTextBox_obj As New updateTextBox_dlgt(AddressOf updateTextBox_ThreadSafe)
            TextBox1.Invoke(updateTextBox_obj, tempStr)

        Else
            Call updateTextBox(tempStr)

        End If
    End Sub

    Public Sub updateCmbClient_ThreadSafe2(ByVal args() As Object)

        Try

            If cmbObjClient.InvokeRequired Then

                Dim updateCmbClient_obj2 As New updateCmbClient_dlgt2(AddressOf updateCmbClient_ThreadSafe2)
                'cmbObjClient.Invoke(updateCmbClient_obj2, args)               'This generates 'Parameter Count Mismatch 
                cmbObjClient.Invoke(updateCmbClient_obj2, New Object() {args}) 'This works 

            Else
                

                Call updateCmbClient2(args)

            End If

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

    
#End Region

#Region "NonThreadSafe"

    Private Sub updateTextBox(ByVal tempStr As String)
        Application.DoEvents()
        TextBox1.AppendText(tempStr)
        TextBox1.Refresh()
    End Sub

    Private Sub updateCmbClient2(ByVal args() As Object)

        Dim tempIndex As Integer
        Dim tempObj As clsClient
        Dim transType As String

        Try

            Application.DoEvents()
            tempIndex = args(0)
            tempObj = args(1)
            transType = args(2)

            If transType = "Add" Then

                '==check if item already exist ============
                If Not cmbObjClient.Items.Count = 0 Then

                    If Not cmbObjClient.Items.Contains(tempObj.VAR_Mykey) Then
                        Call cmbObjClient.Items.Add(tempObj.VAR_Mykey)

                        '--- clone a local copy -------------------------
                        Call CloneObjClient(tempObj, tempIndex)

                        '---- send client welcome message ----------
                        If objAppRemManager.AddItem2ClientTransQCol("Welcome, connected to server", tempObj.VAR_Mykey) Then
                            'MsgBox("Data added successful", MsgBoxStyle.Information)
                        Else
                            'MsgBox("Data added NOT successful", MsgBoxStyle.Critical)
                        End If

                    End If

                Else
                    '--- First time -------------------------------
                    Call cmbObjClient.Items.Add(tempObj.VAR_Mykey)

                    '--- clone a local copy -------------------------
                    Call CloneObjClient(tempObj, tempIndex)

                    '---- send client welcome message ----------
                    If objAppRemManager.AddItem2ClientTransQCol("Welcome, connected to server", tempObj.VAR_Mykey) Then
                        'MsgBox("Data added successful", MsgBoxStyle.Information)
                    Else
                        'MsgBox("Data added NOT successful", MsgBoxStyle.Critical)
                    End If

                End If 'If Not cmbObjClient.Items.Count = 0

            ElseIf transType = "Delete" Then

                If Not cmbObjClient.Items.Count = 0 Then
                    Call cmbObjClient.Items.Remove(tempObj.VAR_Mykey)
                    '--- clear text ---------
                    cmbObjClient.Text = ""
                End If 'If Not cmbObjClient.Items.Count = 0 

            End If ' If transType = "Add" 

            '--- Refresh cmbObjClient ---------
            Call cmbObjClient.Refresh()
            '-----------------------------------

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)

            '===client disconnected, reset remote object reference ====
            tempObj = Nothing
            '======================================

        End Try

    End Sub

    Private Sub CloneObjClient(ByVal tempObj As clsClient, ByVal remoteIndex As Integer)

        Dim localObjClient As clsClient

        If Not tempObj Is Nothing Then
            localObjClient = New clsClient

            localObjClient.VAR_ipAddress = tempObj.VAR_ipAddress
            localObjClient.VAR_Mykey = tempObj.VAR_Mykey
            localObjClient.VAR_remotingPort = tempObj.VAR_remotingPort
            localObjClient.VAR_remotingURL = tempObj.VAR_remotingURL

            If Not localObjClientCol Is Nothing Then
                Call localObjClientCol.Add(localObjClient, CStr(remoteIndex))
            End If 'If Not localObjClientCol Is Nothing

            localObjClient = Nothing

        End If 'If Not tempObj Is Nothing

    End Sub

#End Region

#Region "User Actions"

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Call TextBox1.Clear()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStartSvr.Click
        Dim serverProv As New BinaryServerFormatterSinkProvider()
        serverProv.TypeFilterLevel = System.Runtime.Serialization.Formatters.TypeFilterLevel.Full
        Dim clientProv As New BinaryClientFormatterSinkProvider()
        Dim props As New Hashtable()


        Try
            props.Add("port", txtPortNum.Value)

            '--- make sure channel is not already registered ----

            'Call IsChannelAvail()

            chnl = New HttpChannel(props, clientProv, serverProv)

            '--- create a collection to store index of client to be disconnected later
            Call RefreshDisconnClientIndexCol()
            Call RefreshLocalObjClientCol()

            ChannelServices.RegisterChannel(chnl, False)

            '==== using register wellknown singleton=====================
            'RemotingConfiguration.RegisterWellKnownServiceType( _
            '    GetType(AppRemManager), _
            '    "AppRemManager.soap", _
            '    WellKnownObjectMode.Singleton)
            '==================================================

            '=== Refresh Object =============
            Call RefreshObjAppRemManager()

            '==== Using published marshal =======================
            returnedRemotingObj = RemotingServices.Marshal(objAppRemManager, "AppRemManager.soap")
            '==================================================

            Label1.Text = "Server started!"

        Catch ex1 As System.Net.Sockets.SocketException

            MsgBox("Already started on this port", MsgBoxStyle.Critical)

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSendMessage.Click

        Dim clientID As String
        Dim tempData As String

        Try

            '=== make sure a client is selected ======
            If Not cmbObjClient.SelectedIndex = -1 Then
                clientID = cmbObjClient.SelectedItem.ToString '12 July 2010
                tempData = InputBox("Enter your message")
                If objAppRemManager.AddItem2ClientTransQCol(tempData, clientID) Then
                    MsgBox("Data added successful", MsgBoxStyle.Information)
                Else
                    MsgBox("Data added NOT successful", MsgBoxStyle.Critical)
                End If
            Else
                'clientID = ""  '12 July 2010
                MsgBox("Please select a client first", MsgBoxStyle.Critical)
            End If

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try

    End Sub

    Private Sub cmdStopSvr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdStopSvr.Click

        Try

            If Not objAppRemManager Is Nothing Then

                Call RemotingServices.Disconnect(objAppRemManager)
                Call objAppRemManager.Dispose()

            End If 'If Not objAppRemManager Is Nothing


            If Not chnl Is Nothing Then

                Call ChannelServices.UnregisterChannel(chnl)

            End If 'If Not chnl Is Nothing

            Label1.Text = ""

        Catch ex As Exception
            MsgBox(ex.ToString & vbCrLf & ex.Message & vbCrLf & ex.StackTrace)
        End Try
    End Sub

    Private Sub cmdRestartForm_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRestartForm.Click
        Application.Restart()
    End Sub

#End Region

#Region "Private Events"

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Call StartReadingTimer()
        Call StartRefreshUserTimer()
    End Sub

#End Region

#Region "Public Methods"

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

    End Sub

#End Region

    
End Class



